<?php
require_once("DBManager.class.php");

class cabevaluacion{
	private $idcab;///
	private $iddoc_curso;
	private $titulo;
	private $tiempo;
	private $activo;
	
	
	public function Correlativo()
	{
		$vCorre2 = 1;		
		$vCont = 1;
		$vCeros = "";
		$delta_ceros = 0;
		$AnoSiguiente = 0;
		$AnoActual = 0;
		$fecha = getdate();
		
		$db= new DBManager();	
		$rs=$db->execute("SELECT idcab FROM cabevaluacion ORDER BY idcab;");
		
		//Entra a este bloque si existe algun valor en el campo INroOrd		
		if($rs->lastRow())
		{		
			$vCorre1 = substr($rs->fields['idcab'],0,5);//variable que almacena los 4 primeros caracteres de INroOrd
			$vCorre2 = substr($rs->fields['idcab'],6); //extraigo los ultimos 5 caracteres de INroOrd 			
			$vCorre1 = intval($vCorre1); //obtengo el valor entero
			$vCorre2 = intval($vCorre2); //obtengo el valor entero							
			$vCorre2++;//se incrementa en 1, es decir el correlativo			
			//verifico si el correlativo llega a ocupar los 5 digitos
		 	$delta_ceros = 6 - strlen($vCorre2);			
			if( $delta_ceros == 0 )// Si en el codigo  correlativo ya no existen ceros que poner es decir vCorre2 = 10000
			{
				//Si es que he pasado al siguiente año
				$AnoActual = intval($fecha['year']);
				if($AnoActual>$vCorre1)
				{   
					$AnoSiguiente = $vCorre1+=1;
					return $AnoSiguiente."0000001";
				}
				else{
						return ($vCorre1.$vCorre2);
					}			
			}			
			if( $delta_ceros < 0 /*-1*/)// Si en el codigo correlativo ya no existen ceros que poner y ya llego al limite, en este caso delta_ceros = -1
			{
				$AnoSiguiente = $vCorre1+=1;
				return $AnoSiguiente."0000001";
			}
			
			if( $delta_ceros > 0) // Si en el codigo correlativo existen ceros que poner
			{			
				//Si es que he pasado al siguiente año
				$AnoActual = intval($fecha['year']);
				if($AnoActual>$vCorre1)
				{   
					$AnoSiguiente = $vCorre1+=1;
					return $AnoSiguiente."0000001";
				}
				else{
						for($i=1; $i<$delta_ceros; $i++)
						{
							$vCont++;//contador de ceros
						}			
						$vCeros=str_pad($vCeros,$vCont,'0',STR_PAD_RIGHT);//rellenar de ceros al lado derecho		
						return($vCorre1.$vCeros.$vCorre2);
					}			
			}			

		}else{ 
				//Caso contrario esta vacio el campo al inicio de las acciones				
				return ($fecha['year']."000000".$vCorre2);				
			 }
		$rs->close();
		$db->closeConnection();//opcional			
	}	
	///////////////////////////////////////////
	public function Crear($idcab,$viddoc_curso,$vtitulo,$vtiempo,$vactivo)
	{
		$resp=false;		
		$db= new DBManager();	
	if($db->_execute("INSERT INTO cabevaluacion(idcab,iddoc_curso,titulo,tiempo,activo) VALUES('".$idcab."',".$viddoc_curso.",'".$vtitulo."',".$vtiempo.",'".$vactivo."')"))   
		{
			$resp=true;
		}
		return $resp;		
	}
	
	
	public function ListarPorDocentecurso($v)
	{
		$vector=null;		
		$db= new DBManager();		
		$rs=$db->execute("select * from cabevaluacion where(iddoc_curso =".$v.")");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{
   				$vector[$row]=array("idcab"	    => $rs->fields["idcab"],
									"iddoc_curso" 	=> $rs->fields["iddoc_curso"],
									"titulo" => $rs->fields["titulo"],
									"tiempo" 	    => $rs->fields["tiempo"],
									"activo" => $rs->fields["activo"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
	
	
	public function ListaTodo()
	{
		$vector=null;		
		$db= new DBManager();		
		$rs=$db->execute("select * from cabevaluacion");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{
   				$vector[$row]=array("idcab"	    => $rs->fields["idcab"],
									"iddoc_curso" 	=> $rs->fields["iddoc_curso"],
									"titulo" => $rs->fields["titulo"],
									"tiempo" 	    => $rs->fields["tiempo"],
									"activo" => $rs->fields["activo"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
	
	public function ListarPorDocentecursoEstado($v)
	{
		$vector=null;		
		$db= new DBManager();		
		$rs=$db->execute("select * from cabevaluacion where(iddoc_curso =".$v." and activo = 'Si')");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{
   				$vector[$row]=array("idcab"	    => $rs->fields["idcab"],
									"iddoc_curso" 	=> $rs->fields["iddoc_curso"],
									"titulo" => $rs->fields["titulo"],
									"tiempo" 	    => $rs->fields["tiempo"],
									"activo" => $rs->fields["activo"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
	
	public function ListaPaginada($vcli,$limitInf,$tampag)
	{    /////////////////////////////////////
		$vector=null;		
		$db= new DBManager();			
		$rs=$db->execute("SELECT * FROM cabevaluacion WHERE ( iddoc_curso LIKE CONCAT('%','".$vcli."','%') ) ORDER BY iddoc_curso ASC limit ".$limitInf.",".$tampag.";");			
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{    
   				$vector[$row]=array("idcab"	    => $rs->fields["idcab"],
									"iddoc_curso" 	=> $rs->fields["iddoc_curso"],
									"titulo" => $rs->fields["titulo"],
									"tiempo" 	    => $rs->fields["tiempo"],
									"activo" => $rs->fields["activo"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
	
	
	public function BuscarPorTitulo($v)
	{
		$vector=null;		
		$db= new DBManager();		
		$rs=$db->execute("select * from cabevaluacion where(titulo ='".$v."')");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{
   				$vector[$row]=array("idcab"	    => $rs->fields["idcab"],
									"iddoc_curso" 	=> $rs->fields["iddoc_curso"],
									"titulo" => $rs->fields["titulo"],
									"tiempo" 	    => $rs->fields["tiempo"],
									"activo" => $rs->fields["activo"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
	
	public function BuscarPorCodigo($vcod)
	{
		
		$resp=false;
		$num_rows=0;//numero de filas afectada por la consulta
		$db= new DBManager();
		$rs=$db->execute("select * from cabevaluacion where(idcab = '".$vcod."')");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$resp=true;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) {
                // Coleccion de campos accesible mediante arrays asociativos también
	                  $this->idcab=$rs->fields["idcab"];
				      $this->iddoc_curso=$rs->fields["iddoc_curso"];				
				      $this->titulo=$rs->fields["titulo"];				 
				      $this->tiempo=$rs->fields["tiempo"];
					  $this->activo=$rs->fields["activo"];
 				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
        	}			
		}
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              
		return $resp;							
	}
	
	///////////////////////////////////////////////
		
	public function Actualizar($vidcab,$viddoc_curso,$vtitulo,$vtiempo,$vactivo)			
	{
		$resp=false;		
		$db= new DBManager();		
if($db->_execute("update  cabevaluacion set iddoc_curso = ".$viddoc_curso.", titulo = '".$vtitulo."', tiempo = ".$vtiempo.",activo = '".$vactivo."' where (idcab='".$vidcab."') "))//si es exitosa la consulta			   
		{
		  $resp=true; 
		}	
		return $resp;
	}
	
	public function Actualizarestado($vidcab,$vactivo)			
	{
		$resp=false;		
		$db= new DBManager();		
if($db->_execute("update  cabevaluacion set activo = '".$vactivo."' where (idcab='".$vidcab."') "))//si es exitosa la consulta			   
		{
		  $resp=true; 
		}	
		return $resp;
	}
	
	/////////////////////////////
	public function Eliminar($vcod)
	{
		$resp=false;		
		$db= new DBManager();		
		if($db->_execute("DELETE FROM cabevaluacion WHERE (idcab='".$vcod."');"))   
		{
			$resp=true;
		}
		return $resp;		
	}	
	/////////////////////////////////////////
	
	////////////////////////////////////////							
	
	public function getIdcab(){ return $this->idcab;}
	public function getIddoc_curso(){ return $this->iddoc_curso;}
	public function getTitulo(){ return $this->titulo;}
	public function getTiempo(){ return $this->tiempo;}
	public function getActivo(){ return $this->activo;}
		
}
?>
